Redmine - Feature #1885

Change Start from date to datetime
2008-09-11 05:53 - Stacy Mader

Status: Closed Start date: 2008-09-11
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Time tracking Estimated time: 0.00 hour

Target version:

Resolution: Duplicate

Description

For software bug tracking, it is sometimes good to know the time when the event occurred, so one can verify against log files. The
default column descriptor for Start (start_date) is date, but it would be a nice feature to enable this to datetime.

If this is not possible, it would be good to hide Start on the issue form (c.f. issue 1296).
Cheers.
Redmine 0.7.3.1787 (MySQL)

Ruby 1.8.5
Rails 2.0.2

Related issues:
Is duplicate of Redmine - Feature #5458: Extend Start/Due date to include time New 2010-05-06

History

#1 - 2008-09-12 04:24 - Stacy Mader
Finishing of the last sentence :)

If this is not possible, it would be good to hide Start on the issue form (c.f. issue 1296) and define a new field. Unfortunately it does not look like
datetime is avaiable for creating custom fields.

#2 - 2008-09-12 08:40 - Dmitry Shur
Hi!
I've met the same problem yesterday.

Here's solution - alter table issues in DB (change type for start_date from date to datetime)
Then change some stuff in code.

find in {redmine_dir}/app/views/issues/show.rhtml:  <td style="width:15%"><b><%=I(:field_start_date)%> :</b></td><td style="width:35%"><%=
format_date(@issue.start_date) %></td>

and change it to

{redmine_dir}/app/views/issues/show.rhtml: <_td style="width:15%"><b><%=I(:field_start_date)%> :</b></td><td style="width:35%"><%=
format_datetime(@issue.start_date) %></td>_

In file {redmine_dir}/app/helpers/application_helper.rb add method
def format_datetime(date)

return nil unless date

date.strftime("% Y-%m-%d %H-%M-%S")

end

#3 - 2008-09-15 02:09 - Stacy Mader
Many thanks! | updated the ISSUES table using the following:

mysql> alter table issues modify column field datetime;

Also, | made the changes you mention, however once | restart MySQL and Redmine, | still see only the date on the New issue form - the time is not
present.

Cheers,
Stacy.
#4 - 2008-09-15 09:59 - Dmitry Shur

Stacy, I'm not sure that you've altered table in the right way
I've did it next way - "alter table issues modify start_date datetime;"

Also, I've found out that I've misprinted at my previous note:
instead of _def format_datetime(date) should be def format_datetime(date)

I've faced some problem with updating issues after applying this changes. | haven't investigated yet, where is the problem, hope I'll have enough time
in next couple of days. Anyway, I've made some more imporvements, hope that you won't face bug with updating

#5 - 2008-09-15 10:51 - Dmitry Shur

I've fixed the problem | wrote above. Simply modify due_date column to be datetime =)

#6 - 2008-09-17 05:32 - Stacy Mader

Thanks. Sadly | still only see the date in the Start field. I'm thinking it might be an issue with the javascript calender?

#7 - 2008-09-17 08:38 - Dmitry Shur

Well, and did you try to add time at that field manually?
How it works at my instance - I'm adding new issues/updating existing - field start date is filled in only with current date. Then I'm adding time and
save. After that | can see Start filled with date+time

#8 - 2008-12-10 23:51 - Riccardo Delpopolo

Is useful to have redmine automatically calculate the estimate time.

#9 - 2009-11-10 19:58 - rafael mascayano
Riccardo Delpopolo wrote:
Is useful to have redmine automatically calculate the estimate time.

I've installed version 0.8.4. | made the changes and success. The problem was when | tried to see gantt and calendar visualization. The first one , |
replace:

i_start_date = (i.start_date >= @gantt.date_from ? i.start_date : @gantt.date_from )
i_end_date = (i.due_before <= Qgantt.date_to ? i.due_before : @gantt.date_to )

for
i_end_date = (i.due_before <= @gantt.date_to ? i.due_before : @gantt.date_to )

i_start_date = Date.parse (format_date (i_start_date))
i_end_date = Date.parse (format_date (i_end_date))

Then | change

i_done_date = i.start_date + ((i.due_before - i.start_date+1l)*i.done_ratio/100).floor
i_done_date = (i_done_date <= @gantt.date_from ? Q@gantt.date_from : i_done_date )
i_done_date = (i_done_date >= @gantt.date_to ? @gantt.date_to : i_done_date )

for
i_done_date = i.start_date + ((i.due_before - i.start_date+1l)*i.done_ratio/100).floor
i_done_date = (i_done_date <= @gantt.date_from ? Q@gantt.date_from : i_done_date )
i_done_date = (i_done_date >= @gantt.date_to ? @gantt.date_to : i_done_date )

i_done_date = Date.parse (format_date (i_done_date))

| still have problems with calendar, because it didn't display issues.

#10 - 2013-04-09 14:33 - Dipan Mehta
Add related #11044.

#11 - 2014-08-13 09:23 - Toshi MARUYAMA
- Status changed from New to Closed

- Resolution set to Duplicate

| close as duplicate of #5458.
#5458 has more discussion.
https://www.redmine.org/issues/11044
https://www.redmine.org/issues/5458
https://www.redmine.org/issues/5458

#12 - 2014-08-13 09:23 - Toshi MARUYAMA
- Related to deleted (Feature #11044: Custom field types for time and datetime)

#13 - 2014-08-13 09:23 - Toshi MARUYAMA
- Is duplicate of Feature #5458: Extend Start/Due date to include time added
